CitizenNotifier = {
    name = "CitizenNotifier",

    OSI = {
        callback = {
            bounce =
                function(data)
                    data.offset = 0.5 + 0.5 * math.sin(GetGameTimeMilliseconds() / 1000 * 2)
                end,
        },
    },
}
local alert = false
local alert2 = false

------------------------
--Notification Section--
------------------------
--notifications Show/Hide
function CitizenNotifier.ShowAndHideSample()
    if CitizenBanner_1:IsHidden() then
        CitizenBanner_1:SetText("Banner Position")
        CitizenBanner:SetMovable(true)

        CitizenAlert_1:SetText("Alert Position")
        CitizenAlert:SetMovable(true)

        CitizenBanner_1:SetHidden(false)
        CitizenAlert_1:SetHidden(false)
    else
        CitizenBanner_1:SetHidden(true)
        CitizenAlert_1:SetHidden(true)

        CitizenBanner:SetMovable(false)
        CitizenAlert:SetMovable(false)
    end
end
--Save notifiers new location
function CitizenNotifier.saveUiPosition()
    CitizenAddon.notifier.banner.left = CitizenBanner:GetLeft()
    CitizenAddon.notifier.banner.top = CitizenBanner:GetTop()

    CitizenAddon.notifier.alert.left = CitizenAlert:GetLeft()
    CitizenAddon.notifier.alert.top = CitizenAlert:GetTop()
end

------------------------
--Banner/Alert Section--
------------------------
--Set a Banner
function CitizenNotifier.SetBanner(text)
    if CitizenBanner_1:IsHidden() then
        CitizenBanner_1:SetHidden(false)
    end
    CitizenBanner_1:SetText(text)
end
--Remove a Banner
function CitizenNotifier.RemoveBanner()
    CitizenBanner_1:SetHidden(true)
    CitizenBanner_1:SetText("Banner Position")
end
--Set Banner 2
function CitizenNotifier.SetBanner2(text)
    if CitizenBanner_2:IsHidden() then
        CitizenBanner_2:SetHidden(false)
    end
    CitizenBanner_2:SetText(text)
end
--Remove Banner 2
function CitizenNotifier.RemoveBanner2()
    CitizenBanner_2:SetHidden(true)
    CitizenBanner_2:SetText("Banner 2 Position")
end
--Set Banner 3
function CitizenNotifier.SetBanner3(text)
    if CitizenBanner_3:IsHidden() then
        CitizenBanner_3:SetHidden(false)
    end
    CitizenBanner_3:SetText(text)
end
--Remove Banner 3
function CitizenNotifier.RemoveBanner3()
    CitizenBanner_3:SetHidden(true)
    CitizenBanner_3:SetText("Banner 3 Position")
end
--Remove all banners
function CitizenNotifier.RemoveAllBanners()
    CitizenBanner_1:SetHidden(true)
    CitizenBanner_2:SetHidden(true)
    CitizenBanner_3:SetHidden(true)
    CitizenBanner_1:SetText("Banner Position")
    CitizenBanner_2:SetText("Banner 2 Position")
    CitizenBanner_3:SetText("Banner 3 Position")
end
--Alert
function CitizenNotifier.Alert(text ,time, sound)
    if not alert then
        alert = true
        CitizenAlert_1:SetHidden(false)
        CitizenAlert_1:SetText(text)
        zo_callLater(
            function()
                CitizenAlert_1:SetHidden(true)
                CitizenAlert_1:SetText("Alert Position")
                alert = false
            end,
            time
        )
    elseif alert and not alert2 then
        alert2 = true
        CitizenAlert_2:SetHidden(false)
        CitizenAlert_2:SetText(text)
        zo_callLater(
            function()
                CitizenAlert_2:SetHidden(true)
                CitizenAlert_2:SetText("Alert 2 Position")
                alert2 = false
            end,
            time
        )
    elseif alert and alert2 then
        CitizenAlert_3:SetHidden(false)
        CitizenAlert_3:SetText(text)
        zo_callLater(
            function()
                CitizenAlert_3:SetHidden(true)
                CitizenAlert_3:SetText("Alert 3 Position")
            end,
            time
        )
    else
        zo_callLater(
            function()
                CitizenNotifier.Alert(text ,time, nil)
            end,
            1000
        )
    end
    if sound ~= nil then
        PlaySound(sound)
    end
end

---------------
--OSI Section--
---------------
--Set a icon for player (can have refreshable timer)
function CitizenNotifier.Icon(displayName, icon, size, color, offset, callback, time)
    OSI.SetMechanicIconForUnit(displayName, icon, size, color, offset, callback)

    if time ~= nil then
        EVENT_MANAGER:RegisterForUpdate(CitizenNotifier.name .."IconFor".. displayName, time,
            function ()
                EVENT_MANAGER:UnregisterForUpdate(CitizenNotifier.name .."IconFor".. displayName)
                OSI.RemoveMechanicIconForUnit(displayName)
            end
        )
    end
end
--Remove a icon of a player
function CitizenNotifier.RemoveIcon(displayName)
    OSI.RemoveMechanicIconForUnit(displayName)
end
--Set a world position icon (can have refreshable timer)
function CitizenNotifier.WroldPositionIcon(x, y, z, icon, size, color, offset, callback, time)
    local groundIcon = OSI.CreatePositionIcon(x, y, z, icon, size, color, offset, callback)

    if time ~= nil then
        EVENT_MANAGER:RegisterForUpdate(CitizenNotifier.name .."IconFor".. x..":"..y..":"..z, time,
            function ()
                EVENT_MANAGER:UnregisterForUpdate(CitizenNotifier.name .."IconFor".. x..":"..y..":"..z)
                OSI.DiscardPositionIcon(groundIcon)
                groundIcon = nil
            end
        )
    end
end



---------
--Lists--
---------

-- white = {1,1,1},
-- red = {1,0,0},
-- orange = {1,0.5,0},
-- yellow = {1,1,0},
-- green = {0,1,0},
-- aqua = {0,1,1},
-- blue = {0,0,1},
-- purple = {0.5,0,1},
-- black = {0,0,0},

-- SOUNDS.DUEL_START
-- SOUNDS.DUEL_FORFEIT